<template>
  <div>

    <b-card
      no-body
      class="mb-0"
    >
      
      <b-form
        class="p-5"
        @submit.stop.prevent
      >
      <div class = "title">
        <h4>Registrar nuevo cliente</h4>
      </div>
      <br>
        <b-alert variant="warning" :show="showAlert">Hay un campo vacio</b-alert>
        <b-alert variant="warning" :show="showAlertRequest">{{errorMessageRequest}}</b-alert>
          <b-form-group
            label="Nombre del cliente"
            label-for="name"
            class="w-50"
          >
            <b-form-input
              id="name"
              
              v-model="formData.name"
              autofocus
              maxlength="40"
              trim
              :state="validationName"
              placeholder="Nombre del cliente..."
            />
            <b-form-invalid-feedback :state="validationName">
                Este campo es obligatorio
            </b-form-invalid-feedback>
                   

                  
          </b-form-group>
          
          <b-form-group
              label="RFC"
              label-for="rfc"
              class="w-50"
            >
              <b-form-input
                id="rfc"
                v-model="formData.rfc"
                maxlength="13"
                trim
                :state="validationRfc"
                placeholder="RFC"
              />
              <b-form-invalid-feedback :state="validationRfc">
                  Por favor ingrese un RFC valido, por ejemplo: VECJ880326XXX
              </b-form-invalid-feedback>

                  
          </b-form-group>
          <b-form-group
              label="Moneda de pago"
              label-for="currency"
              class="w-50"
            >
              <b-form-invalid-feedback :state="validationCurrency">
                  Es obligatorio escoger un tipo de moneda
              </b-form-invalid-feedback>
              <v-select
                v-model="formData.currency_type"
                :options="currencyType"
                input-id="currency-type"
                class="payment-selector"
                placeholder="Seleccione una moneda"
                :clearable="false"
              />                
          </b-form-group>

          <div class="d-flex mt-2">
            <b-button

              variant="primary"
              class="mr-2"
              type="submit"
              :disabled="lockedSubmitByName || lockedSubmitByRfc || lockedSubmitByCurrency"
              @click="handleSubmit()"
            >
              Agregar
            </b-button>
            <b-button
  
              type="button"
              @click="$router.back()"
              variant="outline-secondary"
           
            >
              Cancelar
            </b-button>
          </div>
      </b-form>
    </b-card>
    


  </div>
</template>

<script>
import {
  BSidebar, BForm, BFormGroup, BFormInput, BFormInvalidFeedback, BButton,BTab, BTabs, BCard, BAlert, BLink,
} from 'bootstrap-vue'
import vSelect from 'vue-select'
export default {
  components: {
    BTab,
    BTabs,
    BCard,
    BAlert,
    BLink,
    BSidebar,
    BForm,
    BFormGroup,
    BFormInput,
    BFormInvalidFeedback,
    BButton,
    vSelect,
 
  },

  data(){
    return{
      formData:{
        name:'',
        rfc:'',
        currency_type:'',
      },
      showAlert:false,
      showAlertRequest:false,
      hasWrittenName:false,
      hasWrittenRfc:false,
      lockedSubmitByName:true,
      lockedSubmitByRfc:true,
      lockedSubmitByCurrency:true,
      errorMessageRequest:'',
      currencyType:['MXN' , 'USD',],

    }
  },
  methods:{
    handleSubmit(){
      if(this.formData.name==='' || this.formData.rfc==='' || this.formData.currency_type===''){
          this.showAlert=true
          return
      }else{
      
        this.$http.post('clients/create',this.formData).then(res =>{
          if(res.data.message==='agregado'){
            this.$router.push({ name: 'apps-clients-list' })
          }
        }).catch(err=>{
          if (err.response.status == 422){
            console.log('err')
            
            if (err.response.data.errors.rfc){
              this.showAlertRequest = true
              this.errorMessageRequest = err.response.data.errors.rfc[0]
              console.log(err.response.data.errors.rfc[0])
            }
            if (err.response.data.errors.name){
              this.showAlertRequest = true
              this.errorMessageRequest = err.response.data.errors.name[0]
              console.log(err.response.data.errors.name[0])
            }
            if (err.response.data.errors.currency_type){
              this.showAlertRequest = true
              this.errorMessageRequest = err.response.data.errors.currency_type[0]
              console.log(err.response.data.errors.currency_type[0])
            }
          }
        })
      }
            
    },
  },
  computed: {
      validationName() {
        if (this.formData.name.length > 0){
          this.hasWrittenName = true
        } 
        if(this.hasWrittenName && this.formData.name.length > 0 ){
          this.lockedSubmitByName = false
          return true
        }else if(this.hasWrittenName){
          this.lockedSubmitByName = true
          return false
        }
      },
      validationRfc(){
        if (this.formData.rfc.length > 0){
          this.hasWrittenRfc = true
        }
        if(this.hasWrittenRfc){ 
          if (this.formData.rfc !== '') {
            var patt = new RegExp("^[A-Z,Ñ,&]{3,4}[0-9]{2}[0-1][0-9][0-3][0-9][A-Z,0-9]?[A-Z,0-9]?[0-9,A-Z]?$");
            if(patt.test(this.formData.rfc)){
              this.lockedSubmitByRfc = false
              return true
            }else{
              this.lockedSubmitByRfc = true
              return false;
            }
          } else {
              this.lockedSubmitByRfc = true
              return false;
          }
        }
      },
      validationCurrency(){
        if (this.formData.currency_type != ''){
          this.lockedSubmitByCurrency = false
          return true
        }else{
          this.lockedSubmitByCurrency = true
          return false
        }
        
      },
      
     
    },



}
</script>

<style>

</style>
